//#include "main.h"


#include "psp.h"
#include "snes9x.h"
#include <math.h>

#include "img_jpeg.h"

#define TITLE_COL ((31)|(26<<5)|(31<<10))
#define PATH_COL ((31)|(24<<5)|(28<<10))

#define FILE_COL ((20)|(20<<5)|(31<<10))
#define DIR_COL ((8)|(31<<5)|(8<<10))

#define SEL_COL ((30)|(30<<5)|(31<<10))
#define SELDIR_COL ((28)|(31<<5)|(28<<10))


#define INFOBAR_COL ((31)|(24<<5)|(20<<10))

extern u16 os9x_savestate_mini[128*120];
extern u32 new_pad,old_pad;
extern int psp_vsync;
extern int os9x_BG0,os9x_BG1,os9x_BG2,os9x_BG3,os9x_OBJ,os9x_easy,os9x_fastsprite,os9x_applyhacks,os9x_hack;
extern int os9x_smoothing,os9x_softrendering,os9x_apuenabled,os9x_cpuclock,os9x_fskipvalue,os9x_render,os9x_speedlimit,os9x_sndfreq;
extern int os9x_showfps,os9x_showpass,os9x_newrom,os9x_analog_mode,os9x_gammavalue,os9x_snesheight;
extern char LaunchDir[256];
extern char romPath[256];
extern char lastRom[256];
int exit_menu;


extern int ExitCallback(int arg1, int arg2, void *common);

int state_slot=0;
int slot_occupied;

int menu_exitemu(){	
	if (!inputBox("Exit snes9xTYL ?")) return 0;
	ExitCallback(0,0,NULL);
	return 1;
}

int loadstate(){
  char ext[10];
  msgBox("Loading state...",10);
  strcpy(ext,".za0");
  ext[3]=state_slot+48;
  os9x_load(ext);
  return 1;
}

int savestate(){
  char ext[10];
  if (slot_occupied) {
  	if (!inputBox("Overwrite current savestate ?")) return 0;
  }
  msgBox("Saving state...",10);
  strcpy(ext,".za0");
  ext[3]=state_slot+48;
  os9x_save(ext);
  return 1;
}

int menu_reset(){	
	if (!inputBox("Reset Snes ?")) return 0;
	os9x_savesram();
  S9xReset();
  return 1;
}

int menu_browser(){
	os9x_newrom=1;
	return 1;
}

int menu_snapshot() {	
	msgBox("Saving JPEG snapshot...",10);
	os9x_savesnap();	
	return 0;
}

int menu_importstate() {
	char statefilename[256];	
	if (getNoExtFilePath(statefilename,1)==1) {
		debug_log(statefilename);
		msgBox("Importing state...",10);
		os9x_loadfname(statefilename);
	}
	return 0;
}

typedef struct {
		char label[64];
		int (*menu_func)(void);
		int	*value_int;
		int	values_list_size;
		int values_list[16];		
		int value_index;	
		char *values_list_label[16];
} menu_time_t;


int os9x_ignore_fixcol,os9x_ignore_winclip,os9x_ignore_addsub,os9x_ignore_palwrite;
#define DEBUGMENU_ITEMS 13

menu_time_t os9xpsp_debugmenu[DEBUGMENU_ITEMS]={	
	{"Show rendering passes : ",NULL,&os9x_showpass,2,{0,1},0,{"Off","On"}},
	{"Speed hacks : ",NULL,&os9x_applyhacks,2,{0,1},0,{"Off","On"}},
	{"Ignore Fixed Colour : ",NULL,&os9x_ignore_fixcol,2,{0,1},0,{"Off","On"}},
	{"Ignore Windows clipping : ",NULL,&os9x_ignore_winclip,2,{0,1},0,{"Off","On"}},
	{"Ignore Add/Sub modes : ",NULL,&os9x_ignore_addsub,2,{0,1},0,{"Off","On"}},
	{"Ignore Palette writes : ",NULL,&os9x_ignore_palwrite,2,{0,1},0,{"Off","On"}},
	{"OBJ : ",NULL,&os9x_OBJ,2,{0,1},0,{"Off","On"}},
	{"BG0 : ",NULL,&os9x_BG0,2,{0,1},0,{"Off","On"}},	
	{"BG1 : ",NULL,&os9x_BG1,2,{0,1},0,{"Off","On"}},	
	{"BG2 : ",NULL,&os9x_BG2,2,{0,1},0,{"Off","On"}},	
	{"BG3 : ",NULL,&os9x_BG3,2,{0,1},0,{"Off","On"}},
	{"No Transparency : ",NULL,&os9x_easy,2,{0,1},0,{"Off","On"}},	
	{"Fast sprites : ",NULL,&os9x_fastsprite,2,{0,1},0,{"Off","On"}},	
};


int show_debugmenu() {
	//int counter=0;
	unsigned long color=RGB_WHITE;
	static int sel=0;
	int actual_slot;	
	int rows=28,x, y, h, i,j,top=0,pad_cnt=5;
	int new_pad,cpt;
	int retval;		
	char ext[5],slot_fileinfo[32];
	
	
		
	while (get_pad()) pgWaitV();	
	
	os9x_ignore_fixcol=os9x_hack&PPU_IGNORE_FIXEDCOLCHANGES;
	os9x_ignore_winclip=os9x_hack&PPU_IGNORE_WINDOW;
	os9x_ignore_addsub=os9x_hack&PPU_IGNORE_ADDSUB;
	os9x_ignore_palwrite=os9x_hack&PPU_IGNORE_PALWRITE;
	
	//init menu indexes
			
	for (j=0;j<DEBUGMENU_ITEMS;j++) {
		if (os9xpsp_debugmenu[j].value_int) {			//menu entry has a variable
			int cur=*(os9xpsp_debugmenu[j].value_int);    //current value
			for (i=0;i<os9xpsp_debugmenu[j].values_list_size;i++){ //browse list to find index
    		if (cur==os9xpsp_debugmenu[j].values_list[i]) {    			
    			os9xpsp_debugmenu[j].value_index=i;
    			break;
    		}
      }
    }
	}		
	
	{
		
		strcpy(ext,".za0");
		ext[3]=state_slot+48;
		slot_occupied=os9x_getstate(ext,slot_fileinfo);
		actual_slot=state_slot;
	}
	
	old_pad=0;
	cpt=0;
	for(;;){
		show_background(210);
				
    pgDrawFrame(12,12,480-12,272-12,28|(28<<5)|(28<<10));
    pgDrawFrame(11,11,480-11,272-11,30|(30<<5)|(30<<10));
    
    show_batteryinfo();   
    
        	
		new_pad=0;
    if (!pad_cnt) new_pad=get_pad();
    else pad_cnt--;
    pgWaitV();
        
		if (new_pad) {
			if (old_pad==new_pad) pad_cnt=2;
			else pad_cnt=6;
		 	old_pad=new_pad;
		}
		    
		if(new_pad & PSP_CTRL_CIRCLE){
			if (os9xpsp_debugmenu[sel].menu_func) 
				if ((*os9xpsp_debugmenu[sel].menu_func)()) {retval=0;break;}
		}			
    else if(new_pad & PSP_CTRL_CROSS)   { retval= 0;break; }   
    else if(new_pad & PSP_CTRL_UP)      { sel--;    }
    else if(new_pad & PSP_CTRL_DOWN)    { sel++;    }
    else if(new_pad & PSP_CTRL_LTRIGGER)      { sel-=10;if (sel<0) sel=0;    }
    else if(new_pad & PSP_CTRL_RTRIGGER)    { sel+=10;if (sel>=DEBUGMENU_ITEMS) sel=DEBUGMENU_ITEMS-1;    }
    else if(new_pad & PSP_CTRL_LEFT)    {
    	if (os9xpsp_debugmenu[sel].value_int){
    		if (os9xpsp_debugmenu[sel].value_index>0) os9xpsp_debugmenu[sel].value_index--;
    		*(os9xpsp_debugmenu[sel].value_int)=os9xpsp_debugmenu[sel].values_list[os9xpsp_debugmenu[sel].value_index];    		
    	}
    }    
    else if(new_pad & PSP_CTRL_RIGHT)    {
    	if (os9xpsp_debugmenu[sel].value_int){
    		if (os9xpsp_debugmenu[sel].value_index<os9xpsp_debugmenu[sel].values_list_size-1) os9xpsp_debugmenu[sel].value_index++;
    		*(os9xpsp_debugmenu[sel].value_int)=os9xpsp_debugmenu[sel].values_list[os9xpsp_debugmenu[sel].value_index];    		
    	}
    }

		
		if(top > DEBUGMENU_ITEMS-rows)	top=DEBUGMENU_ITEMS-rows;
		if(top < 0)				top=0;
		if(sel >= DEBUGMENU_ITEMS)		sel=0;
		if(sel < 0)				sel=DEBUGMENU_ITEMS-1;
		if(sel >= top+rows)		top=sel-rows+1;
		if(sel < top)			top=sel;
		
       
    pgPrint(1,0,TITLE_COL,"[" EMUNAME_VERSION "] - Menu");
    pgPrint(1,33,INFOBAR_COL,"\1 OK \2 Main menu \5,\7 to select ,\6,\b to change value");


		if(DEBUGMENU_ITEMS > rows){
			h = 219;
			pgDrawFrame(445,25,446,243,(0xd<<0)|(0xd<<5)|(0x17<<10));
			pgFillBox(448, h*top/DEBUGMENU_ITEMS + 25,460, h*(top+rows)/DEBUGMENU_ITEMS + 25,
				(0xd<<0)|(0xd<<5)|(0x17<<10));
			pgFillBox(448+1, h*top/DEBUGMENU_ITEMS + 25+1,460-1, h*(top+rows)/DEBUGMENU_ITEMS + 25 -1,
				(0x17<<0)|(0x17<<5)|(0x1f<<10));
		}
		
		x=4; y=3;
		for(i=0; i<rows; i++){
			if(top+i >= DEBUGMENU_ITEMS) break;
			if(top+i == sel) color = SEL_COL;
			else			 color = FILE_COL;
												
			if (color==SEL_COL) {
				
				if (os9xpsp_debugmenu[top+i].value_int) {
					pgPrintSel(x, y, ((30)|(30<<5)|(31<<10)), os9xpsp_debugmenu[top+i].label);
					if (os9xpsp_debugmenu[top+i].values_list_label[0]) {
						int ind=os9xpsp_debugmenu[top+i].value_index;
						pgPrint(x+strlen(os9xpsp_debugmenu[top+i].label), y, ((31)|(29<<5)|(30<<10)), os9xpsp_debugmenu[top+i].values_list_label[ind]);					
					}	else pgPrintDecTrim(x+strlen(os9xpsp_debugmenu[top+i].label), y, ((31)|(29<<5)|(30<<10)), *(os9xpsp_debugmenu[top+i].value_int));
				} else if (os9xpsp_debugmenu[top+i].menu_func) pgPrintSel(x, y, ((28)|(31<<5)|(28<<10)), os9xpsp_debugmenu[top+i].label);
				else pgPrintSel(x, y, ((24)|(24<<5)|(24<<10)), os9xpsp_debugmenu[top+i].label);
				
			}
			else {				
				if (os9xpsp_debugmenu[top+i].value_int) {
					pgPrint(x, y, ((20)|(20<<5)|(31<<10)), os9xpsp_debugmenu[top+i].label);
					if (os9xpsp_debugmenu[top+i].values_list_label[0]) {
						int ind=os9xpsp_debugmenu[top+i].value_index;
						pgPrint(x+strlen(os9xpsp_debugmenu[top+i].label), y, ((31)|(24<<5)|(24<<10)), os9xpsp_debugmenu[top+i].values_list_label[ind]);					
					}	else pgPrintDecTrim(x+strlen(os9xpsp_debugmenu[top+i].label), y, ((31)|(24<<5)|(24<<10)), *(os9xpsp_debugmenu[top+i].value_int));
				} else if (os9xpsp_debugmenu[top+i].menu_func) pgPrint(x, y, ((16)|(24<<5)|(16<<10)), os9xpsp_debugmenu[top+i].label);
				else pgPrint(x, y, ((20)|(20<<5)|(20<<10)), os9xpsp_debugmenu[top+i].label);
			}																	
			y+=1;
		}
						
		pgScreenFlipV();
		cpt++;

    if(psp_ExitCheck()) {
    	retval=-1;break;
    }
	}
	
	while (get_pad()) pgWaitV();		
	
	os9x_hack=0;
	os9x_hack|=(os9x_ignore_fixcol?PPU_IGNORE_FIXEDCOLCHANGES:0);
	os9x_hack|=(os9x_ignore_winclip?PPU_IGNORE_WINDOW:0);
	os9x_hack|=(os9x_ignore_addsub?PPU_IGNORE_ADDSUB:0);
	os9x_hack|=(os9x_ignore_palwrite?PPU_IGNORE_PALWRITE:0);	
	return retval;	
}

#define MENU_ITEMS 28
menu_time_t os9xpsp_menu[MENU_ITEMS]={
	{"Current slot : ",NULL,&state_slot,4,{0,1,2,3},0,{"Slot 0","Slot 1","Slot 2","Slot 3"}},
	{"Load State",loadstate,NULL,0,NULL,0,NULL},
	{"Save State",savestate,NULL,0,NULL,0,NULL},	
	{"Import savestate",menu_importstate,NULL,0,NULL,0,NULL},	
	{"--------",NULL,NULL,0,NULL,0,NULL},		
	{"Snapshot",menu_snapshot,NULL,0,NULL,0,NULL},		
	{"Reset SNES",menu_reset,NULL,0,NULL,0,NULL},	
	{"--------",NULL,NULL,0,NULL,0,NULL},			
	{"Sound : ",NULL,&os9x_apuenabled,3,{0,1,2},0,{"Off","Emulated/No output","ON"}},
	{"Frequency : ",NULL,&os9x_sndfreq,4,{11025,22050,32000,44100},0,{"11Khz","22Khz","32Khz","44Khz"}},	
	{"--------",NULL,NULL,0,NULL,0,NULL},	
	{"Use analog stick : ",NULL,&os9x_analog_mode,2,{0,1},0,{"Off","On"}},					
	{"GFX engine : ",NULL,&os9x_softrendering,5,{0,1,2,3,4},0,{"Approx. software","Accurate software","PSP Accelerated","PSP accel.+accu.Soft.","PSP accel.+appr.Soft."}},	
	{"Frameskip : ",NULL,&os9x_fskipvalue,7,{0,1,2,3,4,5,10},0,{"0","1","2","3","4","5","Auto"}},	
	{"Rendering : ",NULL,&os9x_render,6,{0,1,2,3,4,5},0,{"1:1","Zoom Fit","Zoom 4/3","Zoom Wide","Full","Full Clipped"}},
	{"Smoothing : ",NULL,&os9x_smoothing,2,{0,1},0,{"Off","On"}},
	{"Speed limit : ",NULL,&os9x_speedlimit,2,{0,1},0,{"Off","On"}},
	{"Video sync : ",NULL,&psp_vsync,2,{0,1},0,{"Off","On"}},	
	{"Gamma correction : ",NULL,&os9x_gammavalue,10,{0,1,2,3,4,5,6,7,8,9},0,NULL},
	{"--------",NULL,NULL,0,NULL,0,NULL},		
	{"CPU clock : ",NULL,&os9x_cpuclock,3,{222,266,333},0,{"222Mhz","266Mhz","333Mhz"}},	
	{"Show FPS : ",NULL,&os9x_showfps,2,{0,1},0,{"Off","On"}},	
	{"--------",NULL,NULL,0,NULL,0,NULL},	
	{"Debug menu",show_debugmenu,NULL,0,NULL,0,NULL},
	{"--------",NULL,NULL,0,NULL,0,NULL},
	{"ROM browser",menu_browser,NULL,0,NULL,0,NULL},
	{"--------",NULL,NULL,0,NULL,0,NULL},		
	{"Exit emulator",menu_exitemu,NULL,0,NULL,0,NULL}
};

void show_batteryinfo(void){
	if (scePowerIsBatteryExist()){
    	struct tm *tsys;
    	time_t cur_time;
			sceKernelLibcTime(&cur_time);
			tsys=localtime(&cur_time);
    	char bat_info[60],bat_time[16];
    	int batteryLifeTime = scePowerGetBatteryLifeTime();
    	if (batteryLifeTime>=0) sprintf(bat_time,"(%02dh%02dm)",batteryLifeTime/60, batteryLifeTime-(batteryLifeTime/60*60));
    	else bat_time[0]=0;
    	sprintf(bat_info,"%02d%c%02d Bat.:%s%s%s%02d%%%s Tmp.%dC",
    	tsys->tm_hour,(tsys->tm_sec&1?':':' '),tsys->tm_min,
    	(scePowerIsPowerOnline()?"Plg.":""),
    	(scePowerIsBatteryCharging()?"Chrg.":""),
	    (scePowerIsLowBattery()?"Low!":""),
	    scePowerGetBatteryLifePercent(),
	    bat_time,
	    scePowerGetBatteryTemp());	    
	    mh_print(479-strlen(bat_info)*5,0,bat_info,(22<<0)|(31<<5)|(22<<10));
		}
}

int showmenu(void) {
	//int counter=0;
	unsigned long color=RGB_WHITE;
	static int sel=0;
	int actual_slot;	
	int rows=28,x, y, h, i,j,top=0,pad_cnt=5;
	int new_pad,cpt;
	int retval;		
	char ext[5],slot_fileinfo[32];
	int cur_engine=os9x_softrendering;
			
	while (get_pad()) pgWaitV();		
	//init menu indexes			
	for (j=0;j<MENU_ITEMS;j++) {
		if (os9xpsp_menu[j].value_int) {			//menu entry has a variable
			int cur=*(os9xpsp_menu[j].value_int);    //current value
			for (i=0;i<os9xpsp_menu[j].values_list_size;i++){ //browse list to find index
    		if (cur==os9xpsp_menu[j].values_list[i]) {    			
    			os9xpsp_menu[j].value_index=i;
    			break;
    		}
      }
    }
	}		
	
	{
		
		strcpy(ext,".za0");
		ext[3]=state_slot+48;
		slot_occupied=os9x_getstate(ext,slot_fileinfo);
		actual_slot=state_slot;
	}
	
	old_pad=0;
	cpt=0;
	for(;;){
		show_background(210);
				
    pgDrawFrame(12,12,480-12,272-12,28|(28<<5)|(28<<10));
    pgDrawFrame(11,11,480-11,272-11,30|(30<<5)|(30<<10));
    
    show_batteryinfo();   
    
        	
		new_pad=0;
    if (!pad_cnt) new_pad=get_pad();
    else pad_cnt--;
    pgWaitV();
        
		if (new_pad) {
			if (old_pad==new_pad) pad_cnt=2;
			else pad_cnt=6;
		 	old_pad=new_pad;
		}
		    
		if(new_pad & PSP_CTRL_CIRCLE){
			if (os9xpsp_menu[sel].menu_func) 
				if ((*os9xpsp_menu[sel].menu_func)()) {retval=0;break;}
		}			
    else if(new_pad & PSP_CTRL_CROSS)   { retval= 0;break; }   
    else if(new_pad & PSP_CTRL_UP)      { sel--;    }
    else if(new_pad & PSP_CTRL_DOWN)    { sel++;    }
    else if(new_pad & PSP_CTRL_LTRIGGER)      { sel-=10;if (sel<0) sel=0;    }
    else if(new_pad & PSP_CTRL_RTRIGGER)    { sel+=10;if (sel>=MENU_ITEMS) sel=MENU_ITEMS-1;    }
    else if(new_pad & PSP_CTRL_LEFT)    {
    	if (os9xpsp_menu[sel].value_int){
    		if (os9xpsp_menu[sel].value_index>0) os9xpsp_menu[sel].value_index--;
    		*(os9xpsp_menu[sel].value_int)=os9xpsp_menu[sel].values_list[os9xpsp_menu[sel].value_index];    		
    	}
    }    
    else if(new_pad & PSP_CTRL_RIGHT)    {
    	if (os9xpsp_menu[sel].value_int){
    		if (os9xpsp_menu[sel].value_index<os9xpsp_menu[sel].values_list_size-1) os9xpsp_menu[sel].value_index++;
    		*(os9xpsp_menu[sel].value_int)=os9xpsp_menu[sel].values_list[os9xpsp_menu[sel].value_index];    		
    	}
    }

		
		if(top > MENU_ITEMS-rows)	top=MENU_ITEMS-rows;
		if(top < 0)				top=0;
		if(sel >= MENU_ITEMS)		sel=0;
		if(sel < 0)				sel=MENU_ITEMS-1;
		if(sel >= top+rows)		top=sel-rows+1;
		if(sel < top)			top=sel;
		
       
    pgPrint(1,0,TITLE_COL,"[" EMUNAME_VERSION "] - Menu");
    pgPrint(1,33,INFOBAR_COL,"\1 OK \2 Return game \5,\7 to select ,\6,\b to change value");


		if(MENU_ITEMS > rows){
			h = 219;
			pgDrawFrame(445,25,446,243,(0xd<<0)|(0xd<<5)|(0x17<<10));
			pgFillBox(448, h*top/MENU_ITEMS + 25,460, h*(top+rows)/MENU_ITEMS + 25,
				(0xd<<0)|(0xd<<5)|(0x17<<10));
			pgFillBox(448+1, h*top/MENU_ITEMS + 25+1,460-1, h*(top+rows)/MENU_ITEMS + 25 -1,
				(0x17<<0)|(0x17<<5)|(0x1f<<10));
		}
		
		x=4; y=3;
		for(i=0; i<rows; i++){
			if(top+i >= MENU_ITEMS) break;
			if(top+i == sel) color = SEL_COL;
			else			 color = FILE_COL;
												
			if (color==SEL_COL) {
				
				if (os9xpsp_menu[top+i].value_int) {
					pgPrintSel(x, y, ((30)|(30<<5)|(31<<10)), os9xpsp_menu[top+i].label);
					if (os9xpsp_menu[top+i].values_list_label[0]) {
						int ind=os9xpsp_menu[top+i].value_index;
						pgPrint(x+strlen(os9xpsp_menu[top+i].label), y, ((31)|(29<<5)|(30<<10)), os9xpsp_menu[top+i].values_list_label[ind]);					
					}	else pgPrintDecTrim(x+strlen(os9xpsp_menu[top+i].label), y, ((31)|(29<<5)|(30<<10)), *(os9xpsp_menu[top+i].value_int));
				} else if (os9xpsp_menu[top+i].menu_func) pgPrintSel(x, y, ((28)|(31<<5)|(28<<10)), os9xpsp_menu[top+i].label);
				else pgPrintSel(x, y, ((24)|(24<<5)|(24<<10)), os9xpsp_menu[top+i].label);
				
			}
			else {				
				if (os9xpsp_menu[top+i].value_int) {
					pgPrint(x, y, ((20)|(20<<5)|(31<<10)), os9xpsp_menu[top+i].label);
					if (os9xpsp_menu[top+i].values_list_label[0]) {
						int ind=os9xpsp_menu[top+i].value_index;
						pgPrint(x+strlen(os9xpsp_menu[top+i].label), y, ((31)|(24<<5)|(24<<10)), os9xpsp_menu[top+i].values_list_label[ind]);					
					}	else pgPrintDecTrim(x+strlen(os9xpsp_menu[top+i].label), y, ((31)|(24<<5)|(24<<10)), *(os9xpsp_menu[top+i].value_int));
				} else if (os9xpsp_menu[top+i].menu_func) pgPrint(x, y, ((16)|(24<<5)|(16<<10)), os9xpsp_menu[top+i].label);
				else pgPrint(x, y, ((20)|(20<<5)|(20<<10)), os9xpsp_menu[top+i].label);
			}																	
			y+=1;
		}
		
		
		{
			u16 *snes_image;
			int x,y,xmax=256/2,ymax=os9x_snesheight/2;
			if (cur_engine<2)	snes_image=(u16*)(0x44000000+512*272*2*2);
			else snes_image=(u16*)(0x44000000+2*512*272*2+256*240*2+2*256*256*2);			
			u16 *dst=pgGetVramAddr(0,0);
			if (!((sel==0)||(sel==1)||(sel==2))) {
				for (y=0;y<ymax;y++)
					for (x=0;x<xmax;x++) {
						int col1=dst[(y+272-ymax-12)*512+x+480-xmax-12];
						int col2a=snes_image[(y*2)*256+(x*2)];
						int col2b=snes_image[(y*2+1)*256+(x*2)];
						int col2c=snes_image[(y*2)*256+(x*2+1)];
						int col2d=snes_image[(y*2+1)*256+(x*2+1)];					
						int col2;
						col2=((((((col2a>>10)&31)+((col2b>>10)&31)+((col2c>>10)&31)+((col2d>>10)&31))>>2)*2/3)<<10);
						col2|=((((((col2a>>5)&31)+((col2b>>5)&31)+((col2c>>5)&31)+((col2d>>5)&31))>>2)*2/3)<<5);
						col2|=((((((col2a>>0)&31)+((col2b>>0)&31)+((col2c>>0)&31)+((col2d>>0)&31))>>2)*2/3)<<0);
						//int col2=snes_image[y*256+x];
						int r1,g1,b1,r2,g2,b2;
						b1=(col1>>10)&31;g1=(col1>>5)&31;r1=(col1>>0)&31;
						b2=(col2>>10)&31;g2=(col2>>5)&31;r2=(col2>>0)&31;
						b1=b1/3+b2; if (b1>31) b1=31;
						g1=g1/3+g2; if (g1>31) g1=31;
						r1=r1/3+r2; if (r1>31) r1=31;
													
						dst[(y+272-ymax-12)*512+x+480-xmax-12]=(b1<<10)|(g1<<5)|(r1);
					}
				int r,g,b;
				float fl=sinf((float)cpt*3.14159f/64.0f);
				b=5+abs(25.0f*fl);
				g=5+abs(25.0f*fl);
				fl=sinf((float)cpt*3.14159f/48.0f);
				r=25+abs(5.0f*fl);
				int col1=r|(g<<5)|(b<<10);
				r=r*9/10;g=g*9/10;b=b*9/10;
				int col2=r|(g<<5)|(b<<10);
				pgDrawFrame(480-xmax-12-2,272-ymax-12-2,480-12,272-12,col2);
		  	pgDrawFrame(480-xmax-12-1,272-ymax-12-1,480-12,272-12,col1);		  	
		  	mh_print(480-128-12-5-5*strlen("[Current game]"),272-ymax-12-2,"[Current game]",(29<<0)|(29<<5)|(29<<10));
			} else {
				for (y=0;y<ymax;y++)
					for (x=0;x<xmax;x++) {
						int col1=dst[(y+272-ymax-12)*512+x+480-xmax-12];
						int col2a=snes_image[(y*2)*256+(x*2)];
						int col2b=snes_image[(y*2+1)*256+(x*2)];
						int col2c=snes_image[(y*2)*256+(x*2+1)];
						int col2d=snes_image[(y*2+1)*256+(x*2+1)];					
						int col2;
						col2=((((((col2a>>10)&31)+((col2b>>10)&31)+((col2c>>10)&31)+((col2d>>10)&31))>>2)*2/3)<<10);
						col2|=((((((col2a>>5)&31)+((col2b>>5)&31)+((col2c>>5)&31)+((col2d>>5)&31))>>2)*2/3)<<5);
						col2|=((((((col2a>>0)&31)+((col2b>>0)&31)+((col2c>>0)&31)+((col2d>>0)&31))>>2)*2/3)<<0);
						//int col2=snes_image[y*256+x];
						int r1,g1,b1,r2,g2,b2;
						b1=(col1>>10)&31;g1=(col1>>5)&31;r1=(col1>>0)&31;
						b2=(col2>>10)&31;g2=(col2>>5)&31;r2=(col2>>0)&31;
						b1=b1+b2/3; if (b1>31) b1=31;
						g1=g1+g2/3; if (g1>31) g1=31;
						r1=r1+r2/3; if (r1>31) r1=31;
													
						dst[(y+272-ymax-12)*512+x+480-xmax-12]=(b1<<10)|(g1<<5)|(r1);
					}
				pgDrawFrame(480-xmax-12-2,272-ymax-12-2,480-12,272-12,14|(14<<5)|(14<<10));
		  	pgDrawFrame(480-xmax-12-1,272-ymax-12-1,480-12,272-12,15|(15<<5)|(15<<10));
		  	mh_print(480-128-12-5-5*strlen("[Current game]"),272-ymax-12-2,"[Current game]",(12<<0)|(12<<5)|(12<<10));
		  	
			}
			
		  
		  if (actual_slot!=state_slot) {
				char ext[5];
				strcpy(ext,".za0");
				ext[3]=state_slot+48;
				slot_occupied=os9x_getstate(ext,slot_fileinfo);
				actual_slot=state_slot;
			}
		  
			if (slot_occupied) {
		  	u16 *dst=pgGetVramAddr(0,0);
		  	if ((sel==0)||(sel==1)||(sel==2)) {
		  		for (y=0;y<os9x_snesheight/2;y++)
						for (x=0;x<128;x++) {
							int r1,g1,b1,r2,g2,b2;
							int col1=dst[(y+13)*512+x+480-128-12];
							int col2=os9x_savestate_mini[y*128+x];
							b1=(col1>>10)&31;g1=(col1>>5)&31;r1=(col1>>0)&31;
							b2=(col2>>10)&31;g2=(col2>>5)&31;r2=(col2>>0)&31;
							b1=b1/3+b2; if (b1>31) b1=31;
							g1=g1/3+g2; if (g1>31) g1=31;
							r1=r1/3+r2; if (r1>31) r1=31;												
							dst[(y+13)*512+x+480-128-12]=(b1<<10)|(g1<<5)|(r1);						
						}
					int r,g,b;
					float fl=sinf((float)cpt*3.14159f/64.0f);
					r=5+abs(25.0f*fl);
					b=5+abs(25.0f*fl);
					fl=sinf((float)cpt*3.14159f/48.0f);					
					g=25+abs(5.0f*fl);
					int col1=r|(g<<5)|(b<<10);
					b=r*9/10;g=g*9/10;b=b*9/10;
					int col2=r|(g<<5)|(b<<10);
					pgDrawFrame(480-128-12-2,11,480-12,13+os9x_snesheight/2,col2);
		  		pgDrawFrame(480-128-12-1,12,480-12,14+os9x_snesheight/2,col1);
		  		mh_print(480-128-12-5-5*strlen("[Current slot]"),14,"[Current slot]",(29<<0)|(29<<5)|(29<<10));
		  		mh_print(480-128-12-5-5*strlen(slot_fileinfo),24,slot_fileinfo,(29<<0)|(29<<5)|(29<<10));
				} else {
					for (y=0;y<os9x_snesheight/2;y++)
						for (x=0;x<128;x++) {
							int r1,g1,b1,r2,g2,b2;
							int col1=dst[(y+13)*512+x+480-128-12];
							int col2=os9x_savestate_mini[y*128+x];
							b1=(col1>>10)&31;g1=(col1>>5)&31;r1=(col1>>0)&31;
							b2=(col2>>10)&31;g2=(col2>>5)&31;r2=(col2>>0)&31;
							b1=b1+b2/3; if (b1>31) b1=31;
							g1=g1+g2/3; if (g1>31) g1=31;
							r1=r1+r2/3; if (r1>31) r1=31;												
							dst[(y+13)*512+x+480-128-12]=(b1<<10)|(g1<<5)|(r1);						
						}
					pgDrawFrame(480-128-12-2,11,480-12,13+os9x_snesheight/2,14|(14<<5)|(14<<10));
		  		pgDrawFrame(480-128-12-1,12,480-12,14+os9x_snesheight/2,15|(15<<5)|(15<<10));
		  		mh_print(480-128-12-5-5*strlen("[Current slot]"),14,"[Current slot]",(12<<0)|(12<<5)|(12<<10));
		  	mh_print(480-128-12-5-5*strlen(slot_fileinfo),24,slot_fileinfo,(12<<0)|(12<<5)|(12<<10));
				}
		  	
		  	
		  }
		}
		
		pgScreenFlipV();
		cpt++;

    if(psp_ExitCheck()) {
    	retval=-1;break;
    }
	}
	
	while (get_pad()) pgWaitV();		
	
	//do some checking & correct values if needed
	//should be done within emu so that user can notice changes...
	if (os9x_fskipvalue==10/*AUTO_FSKIP*/) os9x_speedlimit=1;
	
	return retval;
}



int save_settings(void){
	FILE *f;
	char tmp_str[256];
	int l;	
	sprintf(tmp_str,"%s%s",LaunchDir,"snes9xTYL.ini");
	f = fopen(tmp_str,"wb");			
	if (!f){
		ErrorMsg("cannot save settings");
		return -1;
	}
	l=(VERSION_MAJOR<<16)|VERSION_MINOR;
	fwrite(&l,1,4,f);	
	fwrite(&os9x_apuenabled,1,4,f);
	fwrite(&os9x_sndfreq,1,4,f);
	fwrite(&os9x_softrendering,1,4,f);
	fwrite(&os9x_fskipvalue,1,4,f);
	fwrite(&os9x_speedlimit,1,4,f);
	fwrite(&psp_vsync,1,4,f);
	fwrite(&os9x_showfps,1,4,f);
	fwrite(&os9x_cpuclock,1,4,f);
	fwrite(&os9x_render,1,4,f);
	fwrite(&os9x_smoothing,1,4,f);
	fwrite(&os9x_analog_mode,1,4,f);
	fwrite(&os9x_OBJ,1,4,f);
	fwrite(&os9x_BG0,1,4,f);
	fwrite(&os9x_BG1,1,4,f);
	fwrite(&os9x_BG2,1,4,f);
	fwrite(&os9x_BG3,1,4,f);
	fwrite(&os9x_easy,1,4,f);
	fwrite(&os9x_fastsprite,1,4,f);
	fwrite(&os9x_gammavalue,1,4,f);	
	fwrite(romPath,1,256,f);	
	fwrite(lastRom,1,256,f);	
	fclose(f);
	return 0;
}
int load_settings(void){
	FILE *f;
	char tmp_str[256];
	int l;
	sprintf(tmp_str,"%s%s",LaunchDir,"snes9xTYL.ini");
	f = fopen(tmp_str,"rb");			
	if (!f){
		debug_log("cannot load settings");
		return -1;
	}
	fread(&l,1,4,f);
	if (l>((VERSION_MAJOR<<16)|VERSION_MINOR)){
		debug_log("cannot load settings, too old version");
		fclose(f);
		return -2;
	}
		
#define READ_SETTING(a) \
if (fread(&l,1,4,f)==4) a=l; \
else {fclose(f);return -3;}

//not bigger than tmp_str size, 256
#define READ_SETTING_SIZE(buff,sz) \
if (fread(tmp_str,1,sz,f)==sz) memcpy(buff,tmp_str,sz); \
else {fclose(f);return -3;}
	
	READ_SETTING(os9x_apuenabled)
	READ_SETTING(os9x_sndfreq)
	READ_SETTING(os9x_softrendering)
	READ_SETTING(os9x_fskipvalue)
	READ_SETTING(os9x_speedlimit)
	READ_SETTING(psp_vsync)
	READ_SETTING(os9x_showfps)
	READ_SETTING(os9x_cpuclock)
	READ_SETTING(os9x_render)
	READ_SETTING(os9x_smoothing)
	READ_SETTING(os9x_analog_mode)
	READ_SETTING(os9x_OBJ)
	READ_SETTING(os9x_BG0)
	READ_SETTING(os9x_BG1)
	READ_SETTING(os9x_BG2)
	READ_SETTING(os9x_BG3)
	READ_SETTING(os9x_easy)
	READ_SETTING(os9x_fastsprite)
	READ_SETTING(os9x_gammavalue)	
	READ_SETTING_SIZE(romPath,256)	
	READ_SETTING_SIZE(lastRom,256)	
	
	
	fclose(f);
	return 0;
}

